/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL   50    /* Υߥ */
#define ARC        40    /* ߤΥ */
#define LEFT        0    /* ɤ x ɸ */
#define RIGHT     400    /* ɤ x ɸ */
#define Yr         20    /* ֱߤ y ɸ */
#define Yg         80    /* бߤ y ɸ */
#define Yb        140    /* ıߤ y ɸ */
#define STEP        5    /* 1ޤǰưΥ */
#define LtoR        0    /* ߤΰư: 鱦 */
#define RtoL        1    /* ߤΰư: 麸 */

#define BUFFER0     0    /* Хåե0 */
#define BUFFER1     1    /* Хåե1 */

static GC gc;
static XtIntervalId timeout_id;
static int position = LEFT;  /* ߤαߤ x ɸ */
static int direction = LtoR;  /* LtoR: ˰ư, RtoL: ˰ư */
static Dimension width, height;  /* ΰΥ */

static Colormap colormap;
static unsigned long planes[4], pixels[1];  /* ץ졼ȥ١ԥ */
/* (1) 4Ĥοι¤Τ */
static XColor yellow = {0, 65535, 65535,     0, DoRed | DoGreen | DoBlue, 0};
static XColor red    = {0, 65535,     0,     0, DoRed | DoGreen | DoBlue, 0};
static XColor green  = {0,     0, 65535,     0, DoRed | DoGreen | DoBlue, 0};
static XColor blue   = {0,     0,     0, 65535, DoRed | DoGreen | DoBlue, 0};
/* (2) 顼ޥåѤ: colors0 => BUFFER0, colors1 => BUFFER1 */
static XColor colors0[16], colors1[16];
static Boolean which = BUFFER0;  /* ǽΤϥХåե0 */

static void TimeoutCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg al[20];
    int ac;
    int depth;
    int i;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Animation", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);

    XtRealizeWidget(toplevel);

    /* ɥꥢΥɥΥĴ٤ */
    XtVaGetValues(canvas, XmNwidth, &width,
                          XmNheight, &height, NULL);

    /* եåƥȤ */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* (3) ǥեȤΥ顼ޥåפ */
    colormap = DefaultColormapOfScreen(XtScreen(canvas));

    /* (4) ֥ХåեѤ˥顼դ */
    if (XAllocColorCells(XtDisplay(canvas), colormap,
                         False, planes, 4, pixels, 1) == 0) {
        fprintf(stderr, "Cannot allocate color cells.\n");
        exit(1);
    }

    /* (5) BUFFER0 ѤοѰ */
    /* (6) ƿ 4Ĥĥ顼 */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors0[i] = yellow; /* colors0[]   0 -  3 */
        if ((i / 4) == 1)  colors0[i] = red;    /* colors0[]   4 -  7 */
        if ((i / 4) == 2)  colors0[i] = green;  /* colors0[]   8 - 11 */
        if ((i / 4) == 3)  colors0[i] = blue;   /* colors0[]  11 - 15 */
    }
    /* (7) planes[0]  planes[1] ǿ */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors0[i].pixel = pixels[0];
        if ((i / 4) == 1)  colors0[i].pixel = pixels[0]|planes[0];
        if ((i / 4) == 2)  colors0[i].pixel = pixels[0]|planes[1];
        if ((i / 4) == 3)  colors0[i].pixel = pixels[0]|planes[0]|planes[1];
    }
    /* (8) BUFFER1  planes[2]  planes[3] ͤ˰¸ʤ */
    for (i = 0; i < 16; i++) {
        if ((i % 4) == 1)  colors0[i].pixel |= planes[2];
        if ((i % 4) == 2)  colors0[i].pixel |= planes[3];
        if ((i % 4) == 3)  colors0[i].pixel |= planes[2]|planes[3];
    }

    /* (9) BUFFER1 ѤοѰ */
    /* (10) ƿ 4Ĥĥ顼 */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors1[i] = yellow; /* colors1[]   0 -  3 */
        if ((i / 4) == 1)  colors1[i] = red;    /* colors1[]   4 -  7 */
        if ((i / 4) == 2)  colors1[i] = green;  /* colors1[]   8 - 11 */
        if ((i / 4) == 3)  colors1[i] = blue;   /* colors1[]  11 - 15 */
    }
    /* (11) planes[2]  planes[3] ǿ */
    for (i = 0; i < 16; i++) {
        if ((i / 4) == 0)  colors1[i].pixel = pixels[0];
        if ((i / 4) == 1)  colors1[i].pixel = pixels[0]|planes[2];
        if ((i / 4) == 2)  colors1[i].pixel = pixels[0]|planes[3];
        if ((i / 4) == 3)  colors1[i].pixel = pixels[0]|planes[2]|planes[3];
    }
    /* (12) BUFFER0  planes[0]  planes[1] ͤ˰¸ʤ */
    for (i = 0; i < 16; i++) {
        if ((i % 4) == 1)  colors1[i].pixel |= planes[0];
        if ((i % 4) == 2)  colors1[i].pixel |= planes[1];
        if ((i % 4) == 3)  colors1[i].pixel |= planes[0]|planes[1];
    }

    /* ǽΤ BUFFER0 ʤΤǡɽ BUFFER1 οˤƤ */
    XStoreColors(XtDisplay(canvas), colormap, colors1, 16);

    /* طʿ yellow (١ԥ pixels[0])  */
    XtVaSetValues(canvas, XmNbackground, pixels[0], NULL);

    /* ॢȡХåϿ */
    timeout_id = XtAppAddTimeOut(app_context, INTERVAL, TimeoutCB, canvas);

    XtAppMainLoop(app_context);
}

static void TimeoutCB(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget w = (Widget)client_data;

    /* (13) ץ졼ޥ򥻥å */
    if (which == BUFFER0)
        XSetPlaneMask(XtDisplay(w), gc, planes[0] | planes[1]);
    else
        XSetPlaneMask(XtDisplay(w), gc, planes[2] | planes[3]);

    /* (14) Хåե򥯥ꥢ */
    XSetForeground(XtDisplay(w), gc, 0);
    XFillRectangle(XtDisplay(w), XtWindow(w), gc, 0, 0, width, height);

    /* (15) αߤΰ֤ */
    if (direction == LtoR) {             /* ޤǺ鱦ưƤ */
        position += STEP;                /* ΰ֤˿ʤ */
        if (position > (RIGHT - ARC)) {  /* ɤäȿž */
            position = (RIGHT - ARC) - (position - (RIGHT - ARC));
            direction = RtoL;
        }
    }
    else { /* direction == RtoL */  /* ޤǱ麸ưƤ */
        position -= STEP;           /* ΰ֤˿ʤ */
        if (position < LEFT) {      /* ɤäȿž */
            position = LEFT - (position - LEFT);
            direction = LtoR;
        }
    }

    /* (16) Ʊߤο򥻥åȤơΰ֤˱ߤ */
    XSetForeground(XtDisplay(w), gc, planes[0]|planes[2]);
    XFillArc(XtDisplay(w), XtWindow(w), gc, position, Yr, ARC,ARC, 0*64,360*64);
    XSetForeground(XtDisplay(w), gc, planes[1]|planes[3]);
    XFillArc(XtDisplay(w), XtWindow(w), gc, position, Yg, ARC,ARC, 0*64,360*64);
    XSetForeground(XtDisplay(w), gc, planes[0]|planes[1]|planes[2]|planes[3]);
    XFillArc(XtDisplay(w), XtWindow(w), gc, position, Yb, ARC,ARC, 0*64,360*64);

    /* (17) 顼ޥåפοѹ (̥Хåե̥Хåեؤ) */
    if (which == BUFFER0) {
        XStoreColors(XtDisplay(w), colormap, colors0, 16);
        which = BUFFER1;
    }
    else {
        XStoreColors(XtDisplay(w), colormap, colors1, 16);
        which = BUFFER0;
    }

    /* ƤӥॢȡХåƤӽФ褦ˤ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(w),
                                 INTERVAL, TimeoutCB, w);
}
